/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.esquemaoperacional;

import java.sql.Time;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.DropEvent;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zk.ui.event.InputEvent;
import org.zkoss.zkplus.databind.BindingListModelList;
import org.zkoss.zul.Button;
import org.zkoss.zul.Checkbox;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Comboitem;
import org.zkoss.zul.Datebox;
import org.zkoss.zul.Intbox;
import org.zkoss.zul.Listheader;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Radio;
import org.zkoss.zul.Timebox;

import com.rjconsultores.ventaboletos.constantes.Constantes;
import com.rjconsultores.ventaboletos.dao.ConstanteDAO;
import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Empresa;
import com.rjconsultores.ventaboletos.entidad.EsquemaCorrida;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.Ruta;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.service.HeaderEsquemaCorridaService;
import com.rjconsultores.ventaboletos.service.MarcaService;
import com.rjconsultores.ventaboletos.service.RutaService;
import com.rjconsultores.ventaboletos.service.TramoServicioService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderConfiguracionCorrida;
import com.trg.search.Filter;

/**
 * 
 * @author Rafius
 */
@Controller("busquedaCorridaController")
@Scope("prototype")
public class BusquedaCorridaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<EsquemaCorrida> plwEsquemaCorrida;
	@Autowired
	private MarcaService marcaService;
	@Autowired
	private ClaseServicioService claseService;
	@Autowired
	private RutaService rutaService;
	private MyListbox esquemaCorridaList;
	private Paging pagingEsquemaCorrida;
	private Datebox fecInicio;
	private Datebox fecFinal;
	private Combobox cmbClase;
	private Combobox cmbMarca;
	private Combobox cmbRuta;
	private Combobox cmbEmpresaCorrida;
	private List<Empresa> lsEmpresa;
	private List<Marca> lsMarca;
	private List<ClaseServicio> lsClase;
	private List<Ruta> lsRuta;
	private Button btnPesquisa;
	private Intbox txtID;
	private Intbox txtNumCorrida;
	private Timebox hora;
	private Checkbox chkNaoIncluirLinhaInativa;
	
	private Checkbox chkCorridaCancelada;
	
	private Radio radLatente;
	private Radio radAutorizada;
	private Radio radCancelada;
	private Radio radTodos;
	
	private Listheader listHeader1;
	private Listheader listHeader2;
	private Listheader listHeader3;
	private Listheader listHeader4;
	private Listheader listHeader5;
	private Listheader listHeader6;
	private Listheader listHeader7;
	private Listheader listHeader8;
	private Listheader listHeader9;
	private Listheader listHeader10;
	private Listheader listHeader11;
	private Listheader listHeader12;
	private Listheader listHeader13;
	private Listheader listHeader14;
	private Listheader listHeader15;
	private Listheader listHeader16;
	@Autowired
	private HeaderEsquemaCorridaService headerService;
	
	@Autowired
	private TramoServicioService tramoServicioService;
	
	@Autowired
	private ConstanteDAO constanteDAO;

	public Listheader getListHeader1() {
		return listHeader1;
	}

	public void setListHeader1(Listheader listHeader1) {
		this.listHeader1 = listHeader1;
	}
	
	public Listheader getListHeader2() {
		return listHeader2;
	}

	public void setListHeader2(Listheader listHeader1) {
		this.listHeader2 = listHeader1;
	}

	public Listheader getListHeader3() {
		return listHeader3;
	}

	public void setListHeader3(Listheader listHeader3) {
		this.listHeader3 = listHeader3;
	}

	public Listheader getListHeader4() {
		return listHeader4;
	}

	public void setListHeader4(Listheader listHeader4) {
		this.listHeader4 = listHeader4;
	}

	public Listheader getListHeader5() {
		return listHeader5;
	}

	public void setListHeader5(Listheader listHeader5) {
		this.listHeader5 = listHeader5;
	}

	public Listheader getListHeader6() {
		return listHeader6;
	}

	public void setListHeader6(Listheader listHeader6) {
		this.listHeader6 = listHeader6;
	}

	public Listheader getListHeader7() {
		return listHeader7;
	}

	public void setListHeader7(Listheader listHeader7) {
		this.listHeader7 = listHeader7;
	}

	public Listheader getListHeader8() {
		return listHeader8;
	}

	public void setListHeader8(Listheader listHeader8) {
		this.listHeader8 = listHeader8;
	}

	public Listheader getListHeader9() {
		return listHeader9;
	}

	public void setListHeader9(Listheader listHeader9) {
		this.listHeader9 = listHeader9;
	}

	public Listheader getListHeader10() {
		return listHeader10;
	}

	public void setListHeader10(Listheader listHeader10) {
		this.listHeader10 = listHeader10;
	}

	public Listheader getListHeader11() {
		return listHeader11;
	}

	public void setListHeader11(Listheader listHeader11) {
		this.listHeader11 = listHeader11;
	}

	public Listheader getListHeader12() {
		return listHeader12;
	}

	public void setListHeader12(Listheader listHeader12) {
		this.listHeader12 = listHeader12;
	}

	public Listheader getListHeader13() {
		return listHeader13;
	}

	public void setListHeader13(Listheader listHeader13) {
		this.listHeader13 = listHeader13;
	}

	public Listheader getListHeader14() {
		return listHeader14;
	}

	public void setListHeader14(Listheader listHeader14) {
		this.listHeader14 = listHeader14;
	}

	public Listheader getListHeader15() {
		return listHeader15;
	}

	public void setListHeader15(Listheader listHeader15) {
		this.listHeader15 = listHeader15;
	}

	public Listheader getListHeader16() {
		return listHeader16;
	}

	public void setListHeader16(Listheader listHeader16) {
		this.listHeader16 = listHeader16;
	}

	public Combobox getCmbClase() {
		return cmbClase;
	}

	public void setCmbClase(Combobox cmbClase) {
		this.cmbClase = cmbClase;
	}

	public Combobox getCmbEmpresaCorrida() {
		return cmbEmpresaCorrida;
	}

	public void setCmbEmpresaCorrida(Combobox cmbEmpresaCorrida) {
		this.cmbEmpresaCorrida = cmbEmpresaCorrida;
	}

	public Combobox getCmbRuta() {
		return cmbRuta;
	}

	public void setCmbRuta(Combobox cmbRuta) {
		this.cmbRuta = cmbRuta;
	}

	public List<ClaseServicio> getLsClase() {
		return lsClase;
	}

	public void setLsClase(List<ClaseServicio> lsClase) {
		this.lsClase = lsClase;
	}

	public List<Empresa> getLsEmpresa() {
		return lsEmpresa;
	}

	public void setLsEmpresa(List<Empresa> lsEmpresa) {
		this.lsEmpresa = lsEmpresa;
	}

	public List<Marca> getLsMarca() {
		return lsMarca;
	}

	public void setLsMarca(List<Marca> lsMarca) {
		this.lsMarca = lsMarca;
	}

	public List<Ruta> getLsRuta() {
		return lsRuta;
	}

	public void setLsRuta(List<Ruta> lsRuta) {
		this.lsRuta = lsRuta;
	}

	public Paging getPagingEsquemaCorrida() {
		return pagingEsquemaCorrida;
	}

	public void setPagingEsquemaCorrida(Paging pagingEsquemaCorrida) {
		this.pagingEsquemaCorrida = pagingEsquemaCorrida;
	}

	public MyListbox getEsquemaCorridaList() {
		return esquemaCorridaList;
	}

	public void setEsquemaCorridaList(MyListbox esquemaCorridaList) {
		this.esquemaCorridaList = esquemaCorridaList;
	}

	public PagedListWrapper<EsquemaCorrida> getPlwEsquemaCorrida() {
		return plwEsquemaCorrida;
	}

	public void setPlwEsquemaCorrida(PagedListWrapper<EsquemaCorrida> plwEsquemaCorrida) {
		this.plwEsquemaCorrida = plwEsquemaCorrida;
	}

	public Datebox getFecFinal() {
		return fecFinal;
	}

	public void setFecFinal(Datebox fecFinal) {
		this.fecFinal = fecFinal;
	}

	public Datebox getFecInicio() {
		return fecInicio;
	}

	public void setFecInicio(Datebox fecInicio) {
		this.fecInicio = fecInicio;
	}

	public Button getBtnPesquisa() {
		return btnPesquisa;
	}

	public void setBtnPesquisa(Button btnPesquisa) {
		this.btnPesquisa = btnPesquisa;
	}

	public Combobox getCmbMarca() {
		return cmbMarca;
	}

	public void setCmbMarca(Combobox cmbMarca) {
		this.cmbMarca = cmbMarca;
	}

	public Intbox getTxtID() {
		return txtID;
	}

	public void setTxtID(Intbox txtID) {
		this.txtID = txtID;
	}

	public Timebox getHora() {
		return hora;
	}

	public void setHora(Timebox hora) {
		this.hora = hora;
	}
	
	public Checkbox getChkNaoIncluirLinhaInativa() {
		return chkNaoIncluirLinhaInativa;
	}
	
	public void setChkNaoIncluirLinhaInativa(Checkbox chkNaoIncluirLinhaInativa) {
		this.chkNaoIncluirLinhaInativa = chkNaoIncluirLinhaInativa;
	}

	public void onChange$cmbMarca(InputEvent ev) {
		chkNaoIncluirLinhaInativa.setChecked(false);

		if (ev.isChangingBySelectBack()) {
			return;
		}
		lsRuta = rutaService.obtenerPorEmpresa(((Marca) cmbMarca.getSelectedItem().getValue()).getEmpresa());
		BindingListModelList l = new BindingListModelList(lsRuta, true);
		cmbRuta.setModel(l);
		cmbRuta.setSelectedItem(null);		
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		txtNumCorrida.setMaxlength(Boolean.valueOf(constanteDAO.buscarPorNomeConstante(Constantes.NUM_VIAJE_9_DIGITOS).getValorconstante()) ? 9 : 7);
		lsEmpresa = UsuarioLogado.getUsuarioLogado().getEmpresa();
		lsMarca = marcaService.buscarMarcaPorEmpresa(UsuarioLogado.getUsuarioLogado().getEmpresa());
		lsClase = claseService.obtenerTodos();
		lsRuta = rutaService.obtenerTodos();

		criarListaDinamica();

		btnPesquisa.focus();
		cmbMarca.setSelectedItem(null);

		refreshLista();
		radTodos.setChecked(true);
	}

	Integer posicoesColunasTabela[] = {1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16};
	List<String> labelsList = new ArrayList<>();
	private void criarListaDinamica() {
		
		//Busca do banco as posicoes salvas
		posicoesColunasTabela = headerService.buscarHeader();
		
		esquemaCorridaList.setItemRenderer(new RenderConfiguracionCorrida(posicoesColunasTabela, tramoServicioService));
		
		esquemaCorridaList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				EsquemaCorrida rc = (EsquemaCorrida) esquemaCorridaList.getSelected();
				verPeriodo(rc);
			}
		});
	
		iniciarListHeader(listHeader1);
		iniciarListHeader(listHeader2);
		iniciarListHeader(listHeader3);
		iniciarListHeader(listHeader4);
		iniciarListHeader(listHeader5);
		iniciarListHeader(listHeader6);
		iniciarListHeader(listHeader7);
		iniciarListHeader(listHeader8);
		iniciarListHeader(listHeader9);
		iniciarListHeader(listHeader10);
		iniciarListHeader(listHeader11);
		iniciarListHeader(listHeader12);
		iniciarListHeader(listHeader13);
		iniciarListHeader(listHeader14);
		iniciarListHeader(listHeader15);
		iniciarListHeader(listHeader16);
		
		criarListaDeLabels();
		atualizaLabelsTabela();
	}

	private void criarListaDeLabels() {
		labelsList.add("ZERO");
		labelsList.add(listHeader1.getLabel());
		labelsList.add(listHeader2.getLabel());
		labelsList.add(listHeader3.getLabel());
		labelsList.add(listHeader4.getLabel());
		labelsList.add(listHeader5.getLabel());
		labelsList.add(listHeader6.getLabel());
		labelsList.add(listHeader7.getLabel());
		labelsList.add(listHeader8.getLabel());
		labelsList.add(listHeader9.getLabel());
		labelsList.add(listHeader10.getLabel());
		labelsList.add(listHeader11.getLabel());
		labelsList.add(listHeader12.getLabel());
		labelsList.add(listHeader13.getLabel());
		labelsList.add(listHeader14.getLabel());
		labelsList.add(listHeader15.getLabel());
		labelsList.add(listHeader16.getLabel());
	}

	private void atualizaLabelsTabela() {
		
		int i = 1;
		for(Integer posicao : posicoesColunasTabela) {
			
			if(i == 1) {
				listHeader1.setLabel(labelsList.get(posicao));
			} else if ( i == 2) {
				listHeader2.setLabel(labelsList.get(posicao));
			} else if ( i == 3) {
				listHeader3.setLabel(labelsList.get(posicao));
			} else if ( i == 4) {
				listHeader4.setLabel(labelsList.get(posicao));
			} else if ( i == 5) {
				listHeader5.setLabel(labelsList.get(posicao));
			} else if ( i == 6) {
				listHeader6.setLabel(labelsList.get(posicao));
			} else if ( i == 7) {
				listHeader7.setLabel(labelsList.get(posicao));
			} else if ( i == 8) {
				listHeader8.setLabel(labelsList.get(posicao));
			} else if ( i == 9) {
				listHeader9.setLabel(labelsList.get(posicao));
			} else if ( i == 10) {
				listHeader10.setLabel(labelsList.get(posicao));
			} else if ( i == 11) {
				listHeader11.setLabel(labelsList.get(posicao));
			} else if ( i == 12) {
				listHeader12.setLabel(labelsList.get(posicao));
			} else if ( i == 13) {
				listHeader13.setLabel(labelsList.get(posicao));
			} else if ( i == 14) {
				listHeader14.setLabel(labelsList.get(posicao));
			} else if ( i == 15) {
				listHeader15.setLabel(labelsList.get(posicao));
			} else if ( i == 16) {
				listHeader16.setLabel(labelsList.get(posicao));
			}
			
			i++;
		}
		
	}

	private void iniciarListHeader(Listheader listHeader) {
		listHeader.setDraggable("true");
		listHeader.setDroppable("true");
		
		listHeader.addEventListener("onDrop", new EventListener() {
		      public void onEvent(Event inEvent) throws Exception {
		         
		    	  DropEvent dropEvent = (DropEvent) inEvent;
		    	  Component dragged = dropEvent.getDragged();

		    	  int de = dragged.getParent().getChildren().indexOf(dragged);
		          int para = listHeader.getParent().getChildren().indexOf(listHeader);
		          
		          Integer posicaoDe = posicoesColunasTabela[de];
		          Integer posicaoPara = posicoesColunasTabela[para];
		          
		          posicoesColunasTabela[para] =  posicaoDe;
		          posicoesColunasTabela[de] = posicaoPara;
		          
		          headerService.salvarPosicoesHeader(posicoesColunasTabela);
		          
		          esquemaCorridaList.setItemRenderer(new RenderConfiguracionCorrida(posicoesColunasTabela, tramoServicioService));
		          esquemaCorridaList.renderAll();
		          
		          atualizaLabelsTabela();
		      }
		   });
	}

	private void verPeriodo(EsquemaCorrida rc) {
		if (rc == null) {
			return;
		}

		Map args = new HashMap();
		args.put("esquemaCorrida", rc);
		args.put("busquedaCorridaController", this);
		args.put("esquemaCorridaList", esquemaCorridaList);

		openWindow("/gui/esquema_operacional/editarCorrida.zul",
				Labels.getLabel("editarConfiguracionCorridaController.window.title"), args, MODAL);
	}

	public void onClick$btnPesquisa(Event ev) throws InterruptedException {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verPeriodo(new EsquemaCorrida());
	}

	public void refreshLista() {
		HibernateSearchObject<EsquemaCorrida> busquedaCorrita =
				new HibernateSearchObject<EsquemaCorrida>(EsquemaCorrida.class,
						pagingEsquemaCorrida.getPageSize());

		busquedaCorrita.addFilterEqual("activo", Boolean.TRUE);

		Integer id = txtID.getValue();
		busquedaCorrita.addFilterEqual("esquemacorridaId", id);

		Integer numCorrida = txtNumCorrida.getValue();
		busquedaCorrita.addFilterEqual("numCorrida", numCorrida);

		Date dtHora = hora.getValue();
		if (dtHora != null) {
			Time time = new Time(dtHora.getTime());
			busquedaCorrita.addFilterEqual("horasalida", time);
		}

		Comboitem cbiClase = cmbClase.getSelectedItem();
		ClaseServicio claseServicio = null;
		if (cbiClase != null) {
			claseServicio = (ClaseServicio) cbiClase.getValue();
			busquedaCorrita.addFilterEqual("claseServicio", claseServicio);
		}

		Comboitem cbiMarca = cmbMarca.getSelectedItem();
		Marca marca = null;
		if (cbiMarca != null) {
			marca = (Marca) cbiMarca.getValue();
			busquedaCorrita.addFilterEqual("marca", marca);
		}

		Comboitem cbiRuta = cmbRuta.getSelectedItem();
		Ruta ruta = null;
		if (cbiRuta != null) {
			ruta = (Ruta) cbiRuta.getValue();
			busquedaCorrita.addFilterEqual("ruta", ruta);
		}

		Comboitem cbiEmpresa = cmbEmpresaCorrida.getSelectedItem();
		Empresa empresa = null;
		if (cbiEmpresa != null) {
			empresa = (Empresa) cbiEmpresa.getValue();
			busquedaCorrita.addFilterEqual("empresa", empresa);
		} else {
			busquedaCorrita.addFilterIn("empresa", lsEmpresa);
		}

		if (fecInicio.getValue() != null) {
			Date ini = fecInicio.getValue();
			ini.setHours(00);
			ini.setMinutes(00);
			ini.setSeconds(00);
			busquedaCorrita.addFilterGreaterOrEqual("esquemaOperacional.fecniciovigencia",
					ini);
		}

		if (fecFinal.getValue() != null) {
			Date fin = fecFinal.getValue();
			fin.setHours(23);
			fin.setMinutes(59);
			fin.setSeconds(59);
			busquedaCorrita.addFilterLessOrEqual("esquemaOperacional.fecfinvigencia",
					fin);
		}
		
		if(chkCorridaCancelada.isChecked()) {
			busquedaCorrita.addFilterEqual("indCorridaDesativada", Boolean.TRUE);
		} else {
			busquedaCorrita.addFilterOr( Filter.isNull("indCorridaDesativada"), Filter.equal("indCorridaDesativada", Boolean.FALSE));
		}
		
		if (radAutorizada.isChecked()) {
			busquedaCorrita.addFilterEqual("statusCorrida", "A");
		}else
		if (radCancelada.isChecked()) {
			busquedaCorrita.addFilterEqual("statusCorrida", "C");	
		}else
		if (radLatente.isChecked()) {
			busquedaCorrita.addFilterEqual("statusCorrida", "L");		
		}
		
		busquedaCorrita.addSortDesc("esquemacorridaId");

		plwEsquemaCorrida.init(busquedaCorrita, esquemaCorridaList, pagingEsquemaCorrida);

		if (esquemaCorridaList.getData().length == 0) {
			try {
				Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
						Labels.getLabel("busquedaConfiguracionCorridaController.window.title"),
						Messagebox.OK, Messagebox.INFORMATION);
			} catch (InterruptedException ex) {
			}
		}
	}
	
	public void onClick$chkNaoIncluirLinhaInativa(Event ev) {
		if (chkNaoIncluirLinhaInativa.isChecked()) {
			for (Iterator<Ruta> it = lsRuta.iterator(); it.hasNext();) {
				Ruta ruta = it.next();
				if (Boolean.TRUE.equals(ruta.getIndRutaCancelada())) {
					it.remove();
				}
			}
		} else {
			//Volta aos itens iniciais
			if (cmbMarca.getSelectedItem()==null) {
				lsRuta = rutaService.obtenerTodos();
			} else {
				lsRuta = rutaService.obtenerPorEmpresa(((Marca) cmbMarca.getSelectedItem().getValue()).getEmpresa());
			}
		}
		
		BindingListModelList l = new BindingListModelList(lsRuta, true);
		cmbRuta.setModel(l);
		cmbRuta.setSelectedItem(null);
	}
}
